#!/usr/bin/perl
# indexsoft intuitive mailer
# http://www.indexsoft.com

$|++;
&ReadArgv();

if ($FORK)
{
	$pid = fork();
	if (!defined $pid) { print "can not fork: $!.\n"; exit; }
	elsif ($pid) { exit; } #forked successfully. PID: $pid
}

if ($QUIET) { close STDIN; close STDOUT; open(STDERR, ">&STDOUT"); }

$ENV{'WINDIR'}?($DirSeparator = '\\'):($DirSeparator = '/');
$imlpath = $0; $imlpath =~ s/(delivery.cgi|delive~1.cgi)$//gi;
chop $imlpath; $imlpath = '.' if !$imlpath;
push (@INC, $imlpath); push (@INC, "$imlpath/modules");
require "intuitive.pm";

eval('use DBI;'); die("$@\n") if $@;
$SIG{__WARN__} = sub { print "$_[0]\n"; };
$MLDBH = DBI->connect("DBI:mysql:database=$mySQLDBName;host=$mySQLHost",$mySQLUser,$mySQLPassword);
$sth = $MLDBH->prepare("select pname, pvalue from _iml_tune");
$sth -> execute();
${$pname} = $pvalue while (($pname, $pvalue) = $sth->fetchrow_array());

if (-e $PIDFile)
{
	unless (open(PIDFILE,$PIDFile)) { die("can not open PID file.\n") }
	$pid = <PIDFILE>; close PIDFILE;
	if ($oldpid > 1 && kill(0,$oldpid)) { die("process with PID $pid is already running.\n") }
	else { print "process with PID $pid is long dead.\n" }
}
open (PID, ">$PIDFile") or die("can not create PID file.\n"); print PID $$; close(PID);

eval('use sendmail;'); die("$@\n") if $@;
$sm = new SendMail($SMTP, $SMTPPort);
$sm->setDebug($sm->OFF);

$statement = "select did, dname, dispatch from _iml_dispatches where did in ($DID)";
$statement = "select did, dname, dispatch from _iml_dispatches" if !$DID;
$sth = $MLDBH->prepare($statement);
$sth -> execute();
$dispatches = $sth->rows();
print "started at ",scalar localtime,". ($dispatches dispatches for delivery)\n---\n" if $dispatches;
while(($did, $dname, $dispatch) = $sth->fetchrow_array())
{
	print "start dispatch (ID:$did) $dname\n";
	foreach $line(split(/\255/, $dispatch)) { ($param, $value) = split(/\254/, $line); ${$param} = $value; }
	$BODY =~ s/\n/\r\n/g;
	$MID =~ s/\0/,/g;
	$STATEMENT = "select distinct uname, uemail from _iml_users, _iml_members where muid = uid and mmid in ($MID) and uact = '1'" if (!$STATEMENT);
	$sth2 = $MLDBH->prepare($STATEMENT);
	$sth2 -> execute();
	$found = $sth2->rows();
	print "send messages to $found subscribers\n";
	while (($uname, $uemail) = $sth2->fetchrow_array())
	{
		my ($BODY, $SUBJECT) = ($BODY, $SUBJECT);
		$BODY =~ s/%name%/$uname/g; $BODY =~ s/%email%/$uemail/g;
		$SUBJECT =~ s/%name%/$uname/g;		$SUBJECT =~ s/%email%/$uemail/g;
		$sm->From($FROMEMAIL);		$sm->Subject("$SUBJECT");		$sm->To("$uname <$uemail>");
		$sm->setMailHeader('X-Mailer', 'indexsoft intuitive mailer (http://www.indexsoft.com)');
		$BODY .= "\n-------\nSend by indexsoft intuitive mailer (http://www.indexsoft.com)";
		$sm->setMailBody("$BODY");
		if ($sm->sendMail() != 0) { print "$uemail: ".$sm->{'error'}."\n" }
		$sm->reset();
	}
	$MLDBH -> do("delete from _iml_dispatches where did = $did") if $DEL;
	print "finished (ID:$did)\n---\n";
}
print "stoped at ",scalar localtime,".\n" if $dispatches;
unlink $PIDFile;

#########################
sub ReadArgv
{
	($DID, $DEL, $QUIET) = ();
	my ($line) = ();
	foreach $line(@ARGV)
	{
		# --d=1(2...)
		if ($line =~ '^--d=(\d+)$') { $DID?($DID .= ",$1"):($DID = $1); }
		# --del
		elsif ($line =~ '^--del$') { $DEL = 1; }
		# --mail
		elsif ($line =~ '^--quiet$') { $QUIET = 1; }
		# --fork
		elsif ($line =~ '^--fork$') { $FORK = 1; }
	}
}
